﻿using System;

using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;

namespace Ludo.Android.Client
{
    [Activity(Label = "Ludo.NET", Icon = "@drawable/ic_launcher_ludo")]
    public class GameActivity : Activity
    {
        int count = 1;

        private void NewGame()
        {
            Intent newGame = new Intent(this, typeof(NewGameActivity));
            StartActivity(newGame);
        }

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.Main);

            // Get our button from the layout resource,
            // and attach an event to it
            Button button = FindViewById<Button>(Resource.Id.MyButton);
            button.Click += delegate { button.Text = string.Format("{0} clicks!", count++); };

        }

        public override bool OnCreateOptionsMenu(IMenu menu)
        {
            MenuInflater.Inflate(Resource.Menu.GameActivityMenu, menu);
            return true;
        }

        public override bool OnOptionsItemSelected(IMenuItem item)
        {
            switch(item.ItemId)
            {
                case Resource.Id.new_game:
                    this.NewGame();
                    return true;
                default:
                    return base.OnOptionsItemSelected(item);
            }            
        }
    }
}

