﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Lokeiv.Games.Ludo.MissingStuff
{
    class ThreadHelper
    {
        /// <summary>
        /// Suspends the current thread for a specified time.
        /// </summary>
        /// <param name="millisecondsTimeout">The number of milliseconds for which the thread is blocked. Specify zero (0) to indicate that this thread should be suspended to allow other waiting threads to execute. Specify <see cref="System.Threading.Timeout.Infinite"/> to block the thread indefinately.</param>
        public static void Sleep(int millisecondsTimeout)
        {
#if NETFX_CORE
            new System.Threading.ManualResetEvent(false).WaitOne(millisecondsTimeout);
#else
            System.Threading.Thread.Sleep(millisecondsTimeout);
#endif
        }
    }
}
