﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace Lokeiv.Games.Ludo.Forms.InternetGame.ServiceCallback
{
    [CallbackBehavior(ConcurrencyMode = ConcurrencyMode.Multiple)]
    public class LudoServiceCallback : LudoService.ILudoServiceCallback
    {
        public event EventHandler<LudoServiceClientEventArgs> ClientEnteredGameRoom;
        public event EventHandler<LudoServiceClientEventArgs> ClientLeftGameRoom;
        public event EventHandler<LudoServiceTableEventArgs> TableCreated;
        public event EventHandler<LudoServiceTableEventArgs> ClientEnteredTable;
        public event EventHandler<LudoServiceTableEventArgs> ClientLeftTable;
        public event EventHandler<LudoServiceTableEventArgs> ClientSatDown;
        public event EventHandler<LudoServiceTableEventArgs> ClientRaisedUp;
        public event EventHandler<LudoServiceMessageEventArgs> ClientSentMessageToGameRoom;
        public event EventHandler<LudoServiceMessageEventArgs> ClientSentMessageToTable;

        void LudoService.ILudoServiceCallback.ClientEnteredGameRoom(string nickName)
        {
            if (ClientEnteredGameRoom != null) ClientEnteredGameRoom(this, new LudoServiceClientEventArgs(nickName));
        }

        IAsyncResult LudoService.ILudoServiceCallback.BeginClientEnteredGameRoom(string nickName, AsyncCallback callback, object asyncState)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.EndClientEnteredGameRoom(IAsyncResult result)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.ClientLeftGameRoom(string nickName)
        {
            if (ClientLeftGameRoom != null) ClientLeftGameRoom(this, new LudoServiceClientEventArgs(nickName));
        }

        IAsyncResult LudoService.ILudoServiceCallback.BeginClientLeftGameRoom(string nickName, AsyncCallback callback, object asyncState)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.EndClientLeftGameRoom(IAsyncResult result)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.TableCreated(LudoService.Table table)
        {
            if (TableCreated != null) TableCreated(this, new LudoServiceTableEventArgs(table));
        }

        IAsyncResult LudoService.ILudoServiceCallback.BeginTableCreated(LudoService.Table table, AsyncCallback callback, object asyncState)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.EndTableCreated(IAsyncResult result)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.ClientEnteredTable(LudoService.Table table)
        {
            if (ClientEnteredTable != null) ClientEnteredTable(this, new LudoServiceTableEventArgs(table));
        }

        IAsyncResult LudoService.ILudoServiceCallback.BeginClientEnteredTable(LudoService.Table table, AsyncCallback callback, object asyncState)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.EndClientEnteredTable(IAsyncResult result)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.ClientLeftTable(LudoService.Table table)
        {
            if (ClientLeftTable != null) ClientLeftTable(this, new LudoServiceTableEventArgs(table));
        }

        IAsyncResult LudoService.ILudoServiceCallback.BeginClientLeftTable(LudoService.Table table, AsyncCallback callback, object asyncState)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.EndClientLeftTable(IAsyncResult result)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.ClientSatDown(LudoService.Table table)
        {
            if (ClientSatDown != null) ClientSatDown(this, new LudoServiceTableEventArgs(table));
        }

        IAsyncResult LudoService.ILudoServiceCallback.BeginClientSatDown(LudoService.Table table, AsyncCallback callback, object asyncState)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.EndClientSatDown(IAsyncResult result)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.ClientRaisedUp(LudoService.Table table)
        {
            if (ClientRaisedUp != null) ClientRaisedUp(this, new LudoServiceTableEventArgs(table));
        }

        IAsyncResult LudoService.ILudoServiceCallback.BeginClientRaisedUp(LudoService.Table table, AsyncCallback callback, object asyncState)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.EndClientRaisedUp(IAsyncResult result)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.ClientSentMessageToGameRoom(string nickName, string message)
        {
            if (ClientSentMessageToGameRoom != null) ClientSentMessageToGameRoom(this, new LudoServiceMessageEventArgs(nickName, message));
        }

        IAsyncResult LudoService.ILudoServiceCallback.BeginClientSentMessageToGameRoom(string nickName, string message, AsyncCallback callback, object asyncState)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.EndClientSentMessageToGameRoom(IAsyncResult result)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.ClientSentMessageToTable(string nickName, string tableName, string message)
        {
            if (ClientSentMessageToTable != null) ClientSentMessageToTable(this, new LudoServiceMessageEventArgs(nickName, tableName, message));
        }

        IAsyncResult LudoService.ILudoServiceCallback.BeginClientSentMessageToTable(string nickName, string tableName, string message, AsyncCallback callback, object asyncState)
        {
            throw new NotImplementedException();
        }

        void LudoService.ILudoServiceCallback.EndClientSentMessageToTable(IAsyncResult result)
        {
            throw new NotImplementedException();
        }
    }
}
