﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace Lokeiv.Games.Ludo.Model
{
    public class PieceCollection : List<Piece>, IXmlSerializable
    {
        public Piece this[Guid pieceId]
        {
            get
            {
                return (from p in this where p.PieceId == pieceId select p).FirstOrDefault();
            }
        }

        #region IXmlSerializable
        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }

        public void ReadXml(System.Xml.XmlReader reader)
        {
            throw new NotImplementedException();
        }

        public void ReadXml(System.Xml.XmlReader reader, Board board)
        {
            while (reader.Read())
            {
                if (reader.NodeType == System.Xml.XmlNodeType.Element)
                {
                    switch(reader.Name.ToLower())
                    {
                        case "piece":
                            this.Add(Piece.ReadXml(reader.ReadSubtree(), board));
                            break;
                    }
                }
            }
        }

        public void WriteXml(System.Xml.XmlWriter writer)
        {
            foreach (Piece piece in this)
            {
                writer.WriteStartElement("Piece");
                piece.WriteXml(writer);
                writer.WriteEndElement();
            }                
        }
        #endregion
    }
}
