﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.Windows.Media.Imaging;
using Lokeiv.Games.Ludo.Model;

namespace Ludo.WP7.Client.Utils
{
    public class ColorToGradientStopsConverter : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            System.Windows.Media.Color color1 = Colors.White;
            System.Windows.Media.Color color2 = Colors.Black;
            
            if (targetType == typeof(GradientStopCollection))
            {
                if (value is Lokeiv.Games.Ludo.Model.Color)
                {
                    Lokeiv.Games.Ludo.Model.Color ludoColor = (Lokeiv.Games.Ludo.Model.Color)value;

                    switch (ludoColor)
                    {
                        case Lokeiv.Games.Ludo.Model.Color.Red:
                            color1 = System.Windows.Media.Color.FromArgb(255, 255, 0, 0);
                            color2 = System.Windows.Media.Color.FromArgb(255, 64, 0, 0);
                            break;
                        case Lokeiv.Games.Ludo.Model.Color.Yellow:
                            color1 = System.Windows.Media.Color.FromArgb(255, 255, 255, 0);
                            color2 = System.Windows.Media.Color.FromArgb(255, 64, 64, 0);
                            break;
                        case Lokeiv.Games.Ludo.Model.Color.Green:
                            color1 = System.Windows.Media.Color.FromArgb(255, 0, 255, 0);
                            color2 = System.Windows.Media.Color.FromArgb(255, 0, 64, 0);
                            break;
                        case Lokeiv.Games.Ludo.Model.Color.Blue:
                            color1 = System.Windows.Media.Color.FromArgb(255, 0, 0, 255);
                            color2 = System.Windows.Media.Color.FromArgb(255, 0, 0, 64);
                            break;
                        default:
                            color1 = System.Windows.Media.Colors.White;
                            color2 = System.Windows.Media.Colors.Black;
                            break;
                    }
                }

                GradientStopCollection gsc = new GradientStopCollection();
                gsc.Add(new GradientStop { Color = color1, Offset = 1 });
                gsc.Add(new GradientStop { Color = color2, Offset = -1 });

                return gsc;
            }
            else
            {
                GradientStopCollection gsc = new GradientStopCollection();
                gsc.Add(new GradientStop { Color = color1, Offset = 1 });
                gsc.Add(new GradientStop { Color = color2, Offset = -1 });

                return gsc;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
