﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml.Serialization;
using Ludo.WP7.Client.ViewModels;
using System.IO;
using System.Xml;

namespace Ludo.WP7.Client.Utils
{
    public class DeepSerializer
    {

        public static string SerializeToXml(MainViewModel mainViewModel)
        {
            XmlSerializer serializer = new XmlSerializer(typeof(MainViewModel));

            using (StringWriter stringWriter = new StringWriter())
            {
                serializer.Serialize(stringWriter, mainViewModel);
                string data = stringWriter.ToString();

                return data;
            }
        }

        public static MainViewModel DeserializeMainViewModel(string xml)
        {
            var mainViewModel = new MainViewModel();
            XmlSerializer serializer = new XmlSerializer(typeof(MainViewModel));

            using (StringReader stringReader = new StringReader(xml))
            using (XmlReader xmlReader = XmlReader.Create(stringReader))
            {
                if (serializer.CanDeserialize(xmlReader))
                    try
                    {
                        mainViewModel = (MainViewModel)serializer.Deserialize(xmlReader);
                    }
                    catch (InvalidOperationException)
                    {
                        MessageBox.Show("Unable to load game state.");
                    }
            }

            return mainViewModel;
        }
    }
}
