﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.Windows.Media.Imaging;
using Lokeiv.Games.Ludo.Model;

namespace Ludo.WP7.Client.Utils
{
    public class LudoColorToSolidColorBrushConverter : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            System.Windows.Media.Color color1 = Colors.White;            
            bool reduceOpacity = false;

            if (parameter is string && parameter.ToString().ToLower() == "semitransparent")
                reduceOpacity = true;

            if (targetType == typeof(Brush))
            {
                if (value is Lokeiv.Games.Ludo.Model.Color)
                {
                    Lokeiv.Games.Ludo.Model.Color ludoColor = (Lokeiv.Games.Ludo.Model.Color)value;

                    switch (ludoColor)
                    {
                        case Lokeiv.Games.Ludo.Model.Color.Red:
                            color1 = Colors.Red;
                            //color1 = System.Windows.Media.Color.FromArgb(255, 139, 0, 0);  // DarkRed
                            break;
                        case Lokeiv.Games.Ludo.Model.Color.Yellow:
                            color1 = Colors.Yellow;
                            //color1 = System.Windows.Media.Color.FromArgb(255, 255, 255, 0);  // Yellow
                            break;
                        case Lokeiv.Games.Ludo.Model.Color.Green:
                            color1 = Colors.Green;
                            //color1 = System.Windows.Media.Color.FromArgb(255, 0, 100, 0);  // DarkGreen
                            break;
                        case Lokeiv.Games.Ludo.Model.Color.Blue:
                            color1 = Colors.Blue;
                            //color1 = System.Windows.Media.Color.FromArgb(255, 0, 0, 139);  // DarkBlue
                            break;
                        default:
                            color1 = System.Windows.Media.Colors.White;  // White                            
                            break;
                    }
                }

                if (reduceOpacity)
                {
                    return new SolidColorBrush(ReduceOpacity(color1));
                }
                else
                {
                    return new SolidColorBrush(color1);
                }
            }
            else
            {
                return new SolidColorBrush(color1);
            }
        }

        private System.Windows.Media.Color ReduceOpacity(System.Windows.Media.Color color)
        {
            return System.Windows.Media.Color.FromArgb(128, color.R, color.G, color.B);
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
