﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Ludo.WP7.Client.Utils;

namespace Ludo.WP7.Client.Views
{
    public partial class ErrorPage : BasePage
    {
        public ViewModels.ErrorViewModel ViewModel
        {
            get { return this.DataContext as ViewModels.ErrorViewModel; }
        }

        public ErrorPage()
        {
            InitializeComponent();
            this.DataContext = App.ViewModel.ErrorViewModel;
            this.ViewModel.NavigateToNewGame += NavigateToNewGame;
        }

        protected override void OnNavigatingFrom(System.Windows.Navigation.NavigatingCancelEventArgs e)
        {
            base.OnNavigatingFrom(e);
            this.ViewModel.NavigateToNewGame -= NavigateToNewGame;
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            // If we're navigating from new game and intention is to go back to game, we need to go back once more.
            if(NavigationStack.Instance.IsNavigatingFrom(typeof(NewGamePortraitPage)) && NavigationStack.Instance.Intention == typeof(MainPage))
                NavigationService.GoBack();
        }

        private void NavigateToNewGame(object sender, EventArgs e)
        {
            NavigationService.Navigate(new Uri(@"/Views/NewGamePortraitPage.xaml", UriKind.Relative));
        }
    }
}