﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Ludo.WP7.Client.Utils;

namespace Ludo.WP7.Client.Views
{
    public partial class NewGamePortraitPage : BasePage
    {
        public ViewModels.NewGameViewModel ViewModel
        {
            get { return this.DataContext as ViewModels.NewGameViewModel; }
        }
        
        public NewGamePortraitPage()
        {
            InitializeComponent();
            this.DataContext = App.ViewModel.NewGameViewModel;
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            this.ViewModel.NavigateToPlay += NavigateToPlay;
            this.ViewModel.NavigateToSettings += NavigateToSettings;
        }

        protected override void OnNavigatingFrom(System.Windows.Navigation.NavigatingCancelEventArgs e)
        {
            base.OnNavigatingFrom(e);
            this.ViewModel.NavigateToPlay -= NavigateToPlay;
            this.ViewModel.NavigateToSettings -= NavigateToSettings;
        }

        private void NavigateToPlay(object sender, EventArgs e)
        {
            NavigationStack.Instance.Intention = typeof(MainPage);
            NavigationService.GoBack();
        }

        private void NavigateToSettings(object sender, EventArgs e)
        {
            NavigationService.Navigate(new Uri(@"/Views/SettingsPage.xaml", UriKind.Relative));
        }
    }
}