using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;

namespace Lokeiv.Games.Dice
{
    /// <summary>
    /// Represents the value of a <see cref="Die"/>.
    /// </summary>
    public class DieValue : IXmlSerializable
    {
        protected object _value;
	
        public object Value
        {
            get { return _value; }
        }

        public DieValue(object value)
        {
            this._value = value;
        }

        #region IXmlSerializable        
        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }

        public void ReadXml(System.Xml.XmlReader reader)
        {
            while (reader.Read())
            {
                if (reader.NodeType == System.Xml.XmlNodeType.Element)
                {
                    switch (reader.Name.ToLower())
                    {
                        case "value":
                            string value = reader.ReadInnerXml();
                            
                            if(!string.IsNullOrEmpty(value))
                                this._value = int.Parse(value);
                            
                            break;
                    }
                }
            }
        }

        public void WriteXml(System.Xml.XmlWriter writer)
        {
            writer.WriteStartElement("Value");

            if (this.Value != null)
            {
                if (this.Value is IXmlSerializable)
                    ((IXmlSerializable)this.Value).WriteXml(writer);
                else
                    writer.WriteString(this.Value.ToString());                
            }

            writer.WriteEndElement();
        }
        #endregion
    }
}
