using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;

namespace GameFx.GameClient
{
    public class IsolatedStorageSettings : Dictionary<string, object>
    {

        #region Initialization
        private static IsolatedStorageSettings _applicationSettings;
        public static IsolatedStorageSettings ApplicationSettings
        {
            get 
            {
                if (_applicationSettings == null)
                    _applicationSettings = new IsolatedStorageSettings();

                return _applicationSettings;
            }
        }

        private IsolatedStorageSettings()
        {

        }
        #endregion  // Initialization

        #region Methods
        public bool Contains(string key)
        {
            return this.ContainsKey(key);
        }

        public void Save()
        {
            // Todo: Write file to persistent storage
        }
        #endregion
    }
}