﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GameFx.Entities;

namespace GameFx.GameClient
{
    public class ClientListChangedEventArgs : EventArgs 
    {
        public IEnumerable<Client> ClientsEntered { get; private set; }
        public IEnumerable<Client> ClientsLeft { get; private set; }

        public ClientListChangedEventArgs(Client clientEntered, Client clientLeft)
        {
            if (clientEntered != null)
                this.ClientsEntered = new Client[] { clientEntered }.AsEnumerable();
            else
                this.ClientsEntered = new Client[] { }.AsEnumerable();

            if (clientLeft != null)
                this.ClientsLeft = new Client[] { clientLeft }.AsEnumerable();
            else
                this.ClientsLeft = new Client[] { }.AsEnumerable();
        }

        public ClientListChangedEventArgs(IEnumerable<Client> clientsEntered, IEnumerable<Client> clientsLeft)
        {
            if (clientsEntered != null)
                this.ClientsEntered = clientsEntered;
            else
                this.ClientsEntered = new Client[] { }.AsEnumerable();

            if (clientsLeft != null)
                this.ClientsLeft = clientsLeft;
            else
                this.ClientsLeft = new Client[] { }.AsEnumerable();
        }
    }
}
