﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GameFx.Entities.Messages
{
    public class ChatMessage : ClientMessageBase
    {
        public string Text { get; private set; }

        protected ChatMessage()
            : base()
        {

        }

        public ChatMessage(ClientToken clientToken, string text)
            : base(clientToken)
        {
            this.Text = text;
        }

        #region IXmlSerializable
        public override void ReadXml(System.Xml.XmlReader reader)
        {
            base.ReadXml(reader);

            // Text
            reader.ReadToFollowing("Text");            
            this.Text = reader.ReadInnerXml();
            reader.Skip();
        }

        public override void WriteXml(System.Xml.XmlWriter writer)
        {
            base.WriteXml(writer);

            // Text
            writer.WriteStartElement("Text");
            writer.WriteString(this.Text);
            writer.WriteEndElement();
        }
        #endregion



    }
}
