﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GameFx.Entities.Messages
{
    public abstract class ClientMessageBase : MessageBase
    {
        public ClientToken ClientToken { get; private set; }

        protected ClientMessageBase()
            : base()
        {

        }

        public ClientMessageBase(ClientToken clientToken)
            : base()
        {
            this.ClientToken = clientToken;
        }

        #region IXmlSerializable
        public override void ReadXml(System.Xml.XmlReader reader)
        {
            reader.MoveToContent();
            reader.ReadToDescendant("ClientToken");            
            this.ClientToken = ClientToken.CreateFromXml(reader);
        }

        public override void WriteXml(System.Xml.XmlWriter writer)
        {
            writer.WriteStartElement("ClientToken");
            this.ClientToken.WriteXml(writer);
            writer.WriteEndElement();
        }
        #endregion  // IXmlSerializable
    }
}
