﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;
using System.Threading;
using CommonClient.GameClient;
using CommonClient.GameClient.GameService;
using CommonClient.ViewModels;

namespace WindowsForms.Client
{
    [CallbackBehavior(UseSynchronizationContext = false)]
    public partial class Form1 : Form
    {
        private bool IsDesignMode { get; set; }
        private MainViewModel ViewModel { get; set; }
        private SynchronizationContext _syncContext;

        public Form1()
        {
            InitializeComponent();
            this.IsDesignMode = (LicenseManager.UsageMode == LicenseUsageMode.Designtime);
            this._syncContext = SynchronizationContext.Current;
            this.ViewModel = (MainViewModel)this.viewModelBindingSource.Current;
            this.nickNameTextBox.DataBindings[0].DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged;
            this.chatTextBox.DataBindings[0].DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void chatTextBox_KeyUp(object sender, KeyEventArgs e)
        {
            if (!e.Control && !e.Shift && (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return))
            {
                e.Handled = true;
                this.ViewModel.ChatMessage = this.ViewModel.ChatMessage.Substring(0, this.ViewModel.ChatMessage.Length - 2);  // Remove the last line break
                this.ViewModel.Chat.Execute(null);
            }
        }

    }
}
