﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GameFx.Entities.Messages
{
    public class ConnectMessage : ClientMessageBase
    {
        public Client Client { get; private set; }

        protected ConnectMessage()
            : base()
        {

        }

        public ConnectMessage(Client client)
            : base(client.Token)
        {
            this.Client = client;
        }


        #region IXmlSerializable
        public override void ReadXml(System.Xml.XmlReader reader)
        {
            base.ReadXml(reader);

            // Client
            reader.ReadToFollowing("Client");
            this.Client = Client.CreateFromXml(reader);
            reader.ReadEndElement();
        }

        public override void WriteXml(System.Xml.XmlWriter writer)
        {
            base.WriteXml(writer);

            // Client
            writer.WriteStartElement("Client");
            this.Client.WriteXml(writer);
            writer.WriteEndElement();
        }
        #endregion
    }
}
