﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GameFx.Entities.Messages
{
    public class EnterLeaveMessage : MessageBase
    {
        public Client Client { get; private set; }
        public EnterLeave EnterOrLeave { get; private set; }

        protected EnterLeaveMessage()
            : base()
        {

        }

        public EnterLeaveMessage(Client client, EnterLeave enterOrLeave)
            : base()
        {
            this.Client = client;
            this.EnterOrLeave = enterOrLeave;
        }

        #region IXmlSerializable
        public override void ReadXml(System.Xml.XmlReader reader)
        {
            // Client
            reader.ReadToFollowing("Client");
            this.Client = GameFx.Entities.Client.CreateFromXml(reader);
            reader.Skip();

            // EnterOrLeave
            reader.ReadToFollowing("EnterOrLeave");
            this.EnterOrLeave = (EnterLeave)System.Enum.Parse(typeof(EnterLeave), reader.ReadInnerXml(), true);
            reader.Skip();
        }

        public override void WriteXml(System.Xml.XmlWriter writer)
        {
            // Client
            writer.WriteStartElement("Client");
            this.Client.WriteXml(writer);
            writer.WriteEndElement();

            // EnterOrLeave
            writer.WriteStartElement("EnterOrLeave");
            writer.WriteString(this.EnterOrLeave.ToString());
            writer.WriteEndElement();
        }
        #endregion  // IXmlSerializable
    }
}
