﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SignalR;

namespace GameFx.Server.Console
{
    public class GameFxConnection : PersistentConnection
    {
        private ConsoleLogger logger;

        public GameFxConnection()
            : base()
        {
            this.logger = new ConsoleLogger();
        }

        protected override System.Threading.Tasks.Task OnConnectedAsync(SignalR.Hosting.IRequest request, string connectionId)
        {
            this.logger.Write(string.Format("{0} connected", connectionId));
            return base.OnConnectedAsync(request, connectionId);
        }

        protected override System.Threading.Tasks.Task OnDisconnectAsync(string connectionId)
        {
            this.logger.Write(string.Format("{0} disconnected", connectionId));
            return base.OnDisconnectAsync(connectionId);
        }
    }
}
