using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;

namespace Lokeiv.Games.Ludo.Model
{
    public class Block : IXmlSerializable
    {
        private Color _color;

        public Color Color
        {
            get
            {
                return this._color;
            }
        }

        public Block(Color color)
        {
            this._color = color;
        }

        #region IXmlSerializable
        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }

        public void ReadXml(System.Xml.XmlReader reader)
        {
            reader.MoveToContent();

            if (!reader.IsEmptyElement)
            {
                string color = reader.GetAttribute("Color");
                this._color = (Model.Color)Enum.Parse(typeof(Model.Block), color, true);
            }
        }

        public void WriteXml(System.Xml.XmlWriter writer)
        {
            writer.WriteAttributeString("Color", this.Color.ToString());
        }
        #endregion
    }
}
