﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.Windows.Media.Imaging;

namespace Ludo.WP7.Client.Utils
{
    public class IntToDieImageConverter : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (targetType == typeof(ImageSource))
            {
                if (value is int)
                {
                    int i = (int)value;
                    string path;

                    switch(i)
                    {
                        case 1:
                            path = @"\Images\Die_1.png";
                            break;
                        case 2:
                            path = @"\Images\Die_2.png";
                            break;
                        case 3:
                            path = @"\Images\Die_3.png";
                            break;
                        case 4:
                            path = @"\Images\Die_4.png";
                            break;
                        case 5:
                            path = @"\Images\Die_5.png";
                            break;
                        default:
                            path = @"\Images\Die_6.png";
                            break;
                    }

                    ImageSource imageSource = new ImageSourceConverter().ConvertFromString(path) as ImageSource;
                    return imageSource;
                }
                else if (value is Uri)
                {
                    Uri uri = (Uri)value;
                    return new ImageSourceConverter().ConvertFromString(uri.AbsolutePath);
                }
            }

            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
