﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.Windows.Media.Imaging;
using Lokeiv.Games.Ludo.Model;

namespace Ludo.WP7.Client.Utils
{
    public class NewGamePlayerTypeToImageConverter : IMultiValueConverter
    {

        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (values != null && values.Length == 2)
            {
                if (values[0] is ViewModels.NewGamePlayerViewModel.NewGamePlayerType && values[1] is Lokeiv.Games.Ludo.Model.Color)
                {
                    ViewModels.NewGamePlayerViewModel.NewGamePlayerType playerType = (ViewModels.NewGamePlayerViewModel.NewGamePlayerType)values[0];
                    Lokeiv.Games.Ludo.Model.Color playerColor = (Lokeiv.Games.Ludo.Model.Color)values[1];
                    string path;
                    string color = playerColor.ToString();

                    switch(playerType)
                    {
                        case ViewModels.NewGamePlayerViewModel.NewGamePlayerType.NoPlayer:
                            path = string.Format(@"Images\NoPlayer{0}.png", color);
                            break;
                        case ViewModels.NewGamePlayerViewModel.NewGamePlayerType.Computer:
                            path = string.Format(@"Images\Phone{0}.png", color);
                            break;
                        default:
                            path = string.Format(@"Images\Human{0}.png", color);
                            break;
                    }

                    ImageSource imageSource = new ImageSourceConverter().ConvertFromString(path) as ImageSource;
                    return imageSource;
                }           
            }

            return null;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
