﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace Lokeiv.Games.Ludo.Service
{
    [ServiceContract(CallbackContract = typeof(ILudoServiceCallback))]
    public interface ILudoService
    {
        [OperationContract]
        GameRoom GetGameRoom();

        [OperationContract]
        Client EnterWithNickName(string nickName);

        [OperationContract(IsOneWay = true)]
        void LeaveGameRoom(string nickName);

        [OperationContract]
        Table CreateTable(string name);

        [OperationContract]
        void EnterTable(string nickName, string tableName);

        [OperationContract]
        void LeaveTable(string nickName, string tableName);

        [OperationContract(IsOneWay = true)]
        void SitDown(string nickName, string tableName, Lokeiv.Games.Ludo.Model.Color color);

        [OperationContract(IsOneWay = true)]
        void RaiseUp(string nickName, string tableName);

        [OperationContract(IsOneWay = true)]
        void SendMessageToGameRoom(string nickName, string message);

        [OperationContract(IsOneWay = true)]
        void SendMessageToTable(string nickName, string tableName, string message);

        [OperationContract]
        List<Client> GetClients();

        [OperationContract]
        List<Table> GetTables();

        [OperationContract]
        Table RefreshTable(string tableName);

        [OperationContract(IsOneWay = true)]
        void KeepConnection();
    }
}
