using System;
using System.Collections.Generic;
using System.Text;

namespace Lokeiv.Games.Dice
{
    public class NumericOneToSixDie : Die
    {
        /// <summary>
        /// Contructor that initializes the dies value to 6.
        /// </summary>
        public NumericOneToSixDie()
        {
            this._value = new DieValue(6);
        }

        /// <summary>
        /// Produces a new random value from 1 to 6.
        /// </summary>        
        protected override DieValue GetNewRandomValue()
        {
            int value = this._randomizer.Next(1, 7);
            return new DieValue(value);
        }

        #region IXmlSerializable
        public override void ReadXml(System.Xml.XmlReader reader)
        {
            while (reader.Read())
            {
                if (reader.NodeType == System.Xml.XmlNodeType.Element)
                {
                    switch (reader.Name.ToLower())
                    {
                        case "value":
                            string value = reader.ReadInnerXml();
                            this._value = new DieValue(int.Parse(value));
                            break;
                    }
                }
            }
        }
        #endregion
    }
}
