using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Lokeiv.Games.Ludo.Forms.InternetGame
{
    public partial class LudoRoom : Form
    {
        private Ludo.LudoService _ludoService;
        private Ludo.Client _client;
        private Ludo.GameRoom _gameRoom;
        private List<Ludo.Client> _clients = new List<Lokeiv.Games.Ludo.Forms.InternetGame.Ludo.Client>();
        private List<Ludo.Table> _tables = new List<Lokeiv.Games.Ludo.Forms.InternetGame.Ludo.Table>();
        private List<LudoTable> _tableFormsOpen = new List<LudoTable>();

        public List<LudoTable> TableFormsOpen
        {
            get { return _tableFormsOpen; }            
        }	

        public LudoRoom()
        {
            InitializeComponent();
            this._ludoService = new Ludo.LudoService();
            NickNameForm nickNameForm = new NickNameForm(this._ludoService);

            if (nickNameForm.ShowDialog() == DialogResult.OK)
            {
                this._client = nickNameForm.Client;
            }
            else
            {
                this.Close();
            }
        }

        /// <summary>
        /// Updates the list of clients.
        /// </summary>
        private void UpdateClientsList()
        {
            this.clientsListView.Items.Clear();

            foreach(Ludo.Client client in this._clients)
            {
                this.clientsListView.Items.Add(client.NickName);
            }
        }

        private void LudoRoom_Shown(object sender, EventArgs e)
        {
            // Load list of clients and room state once the form is displayed
            this._gameRoom = this._ludoService.GetGameRoom();
            this._clients.AddRange(this._gameRoom.Clients);
            this._tables.AddRange(this._gameRoom.Tables);
            this.UpdateClientsList();
        }

        private void LudoRoom_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (this._tableFormsOpen.Count == 0)
            {
                Application.Exit();
            }
        }
    }
}