using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Ascend;
using Ascend.Windows.Forms;

namespace Lokeiv.Games.Ludo.Forms.InternetGame
{       
    class LudoTableRender : GradientBackgroundRender
    {
        private int _posOffset = 2;


        /// <summary>
        /// Draws a table in the <see cref="LudoTables">control</see>.
        /// </summary>
        /// <param name="e">A System.Windows.Forms.PaintEventArgs that contains the event data.</param>
        public override void Render(System.Windows.Forms.PaintEventArgs e)
        {
            if (e == null)
            {
                throw new ArgumentNullException("e");
            }

            RectangleF bounds;
            float topOffset = (this._posOffset + base.Padding.Top + this.Border.Top);
            float leftPosition = (this.DisplayRectangle.Left + base.Padding.Left + this._posOffset);
            float topPosition = (this.DisplayRectangle.Top + this._posOffset + base.Padding.Top + this.Border.Top);
            float rightOffset = (this._posOffset + base.Padding.Right + this.Border.Right);
            float bottomOffset = (this._posOffset + base.Padding.Bottom + this.Border.Bottom);
            bounds = new RectangleF(leftPosition, topPosition, (this.DisplayRectangle.Width - (leftPosition + rightOffset)), (this.DisplayRectangle.Height - (topOffset + bottomOffset)));

            if (this.DisplayRectangle.Height > 0 && this.DisplayRectangle.Width > 0)
            {
                base.Render(e);                

                if (!bounds.IsEmpty)
                {
                }
            }
        }
    }
}
