using System;
using System.Collections.Generic;
using System.Text;

namespace Lokeiv.Games.Ludo.Model
{
    public class GameOptions
    {
        private GameType _gameType;
        private bool _rollThreeTimes;
        private bool _formBlocks;
	            

        #region Public properties

        /// <summary>
        /// Wheter or not two or more pieces of the same color on the same square should form 
        /// a block for pieces of other colors.
        /// </summary>
        public bool FormBlocks
        {
            get { return _formBlocks; }
            set { _formBlocks = value; }
        }

        /// <summary>
        /// Whether or not the die should be rolled three times when all
        /// pieces are in the house. If allowed, players are able to start faster.
        /// </summary>
        public bool RollThreeTimes
        {
            get { return _rollThreeTimes; }
            set { _rollThreeTimes = value; }
        }

        /// <summary>
        /// The type of Ludo to play, like Classic or the one with stars and earth.
        /// </summary>
        public GameType GameType
        {
            get { return _gameType; }
            set { _gameType = value; }
        }

        #endregion

        /// <summary>
        /// Creates a classic game type with default options.
        /// </summary>
        public GameOptions()
        {
            this.GameType = GameType.Classic;
        }
    }
}
