using System;
using System.Collections.Generic;
using System.Text;
using Lokeiv.Games.Dice;

namespace Lokeiv.Games.Ludo.Model
{
    public class Response
    {
        private DieValue _dieValue = null;
        private List<MoveablePiece> _movablePieces = new List<MoveablePiece>();
        private Player _playersTurn = null;
        private Player _playerWon = null;
        private Action _nextAction = Action.Nothing;

        #region Properties
        public DieValue DieValue
        {
            get { return this._dieValue; }
            set { this._dieValue = value; }
        }

        public List<MoveablePiece> MovablePieces
        {
            get { return this._movablePieces; }
            set { this._movablePieces = value; }
        }

        public Player PlayersTurn
        {
            get { return this._playersTurn; }
            set { this._playersTurn = value; }
        }

        public Player PlayerWon
        {
            get { return this._playerWon; }
            set { this._playerWon = value; }
        }

        public Action NextAction
        {
            get { return this._nextAction; }
            set { this._nextAction = value; }
        }
        #endregion

        #region Contructors
        public Response() { }

        public Response(DieValue dieValue, Player playersTurn, Action nextAction)
        {
            this._dieValue = dieValue;
            this._playersTurn = playersTurn;
            this._nextAction = nextAction;
        }

        public Response(Player playerWon, Action nextAction)
        {
            this._playerWon = playerWon;
            this._nextAction = nextAction;
        }
        #endregion

    }
}
