using System;
using System.Collections.Generic;
using System.Text;
using Lokeiv.Games.Dice;

namespace Lokeiv.Games.Ludo.Model.Rules
{
    public abstract class Rule
    {
        protected List<Rule> _excludesRules = new List<Rule>();
        protected List<Rule> _excludedByRules = new List<Rule>();
        private bool _enabled = true;

        public bool Enabled
        {
            get { return _enabled; }
            set { _enabled = value; }
        }

        public List<Rule> ExcludedByRules
        {
            get { return this._excludedByRules; }
        }

        public List<Rule> ExcludesRules
        {
            get { return this._excludesRules; }
        }

        protected Rule()
        {
            this.SetExcludedByRules();
            this.SetExludesRules();
        }

        protected abstract void SetExludesRules();
        protected abstract void SetExcludedByRules();
        public abstract List<MoveablePiece> GetPossibleMoves(Die die, Piece piece);
    }
}
