using System;
using System.Collections.Generic;
using System.Text;

namespace Lokeiv.Games.Ludo.Model
{
    public class Square
    {
        private Color _color = Color.White;
        private int _number = 0;
        private Boolean _isCrossing = false;  // crossing is the square outside of the house
        private Boolean _isHouse = false;
        private Boolean _isGoal = false;
        private List<Piece> _pieces = new List<Piece>();
        private Square _nextSquare = null;
        private Square _alternateSquare = null;
        private Block _block = null;

        #region Properties
        public Color Color
        {
            get { return this._color; }            
        }

        public int Number
        {
            get { return this._number; }            
        }

        public Boolean IsCrossing
        {
            get { return this._isCrossing; }            
        }

        public Boolean IsHouse
        {
            get { return this._isHouse; }            
        }

        public Boolean IsGoal
        {
            get { return this._isGoal; }
        }

        public List<Piece> Pieces
        {
            get { return this._pieces; }
        }

        public Square NextSquare
        {
            get { return this._nextSquare; }
        }

        public Square AlternateSquare
        {
            get { return this._alternateSquare; }
        }

        public Block Block
        {
            get { return this._block; }
        }

#endregion

        #region Constructors
        internal Square(Color color, int number)
        {
            this._color = color;
            this._number = number;
        }
        #endregion

        #region Internal Methods
        internal void SetColor(Color color)
        {
            this._color = color;
        }

        internal void SetNumber(int number)
        {
            this._number = number;
        }

        internal void SetCrossing(Boolean isCrossing)
        {
            this._isCrossing = isCrossing;
        }

        internal void SetHouse(Boolean isHouse)
        {
            this._isHouse = isHouse;
        }

        internal void SetGoal(Boolean isGoal)
        {
            this._isGoal = isGoal;
        }

        internal void SetNextSquare(Square square)
        {
            this._nextSquare = square;
        }

        internal void SetAlternateSquare(Square square)
        {
            this._alternateSquare = square;
        }

        internal void SetBlock(Block block)
        {
            this._block = block;
        }
        #endregion

    }
}
