﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Ludo.Silverlight.Application
{
    public partial class Board : UserControl
    {
        private List<Rectangle> _squares = new List<Rectangle>();

        public Board()
        {
            InitializeComponent();
            this.AddShapesToCollections();
            this.SizeChanged += new SizeChangedEventHandler(Board_SizeChanged);
            this.Loaded += new RoutedEventHandler(Board_Loaded);
        }

        void Board_Loaded(object sender, RoutedEventArgs e)
        {
            this.ResizeBoard(this.RenderSize);
        }

        void Board_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            this.ResizeBoard(e.NewSize);
        }

        /// <summary>
        /// Adds all squares to a collection, to make them easier to resize.
        /// </summary>
        void AddShapesToCollections()
        {
            this._squares.Add(this.Square0);
            this._squares.Add(this.Square1);
            this._squares.Add(this.Square2);
            this._squares.Add(this.Square3);
            this._squares.Add(this.Square4);
            this._squares.Add(this.Square5);
            this._squares.Add(this.Square6);
            this._squares.Add(this.Square7);
            this._squares.Add(this.Square8);
            this._squares.Add(this.Square9);
            this._squares.Add(this.Square10);
            this._squares.Add(this.Square11);
            this._squares.Add(this.Square12);
            this._squares.Add(this.Square13);
            this._squares.Add(this.Square14);
            this._squares.Add(this.Square15);
            this._squares.Add(this.Square16);
            this._squares.Add(this.Square17);
            this._squares.Add(this.Square18);
            this._squares.Add(this.Square19);
            this._squares.Add(this.Square20);
            this._squares.Add(this.Square21);
            this._squares.Add(this.Square22);
            this._squares.Add(this.Square23);
            this._squares.Add(this.Square24);
            this._squares.Add(this.Square25);
            this._squares.Add(this.Square26);
            this._squares.Add(this.Square27);
            this._squares.Add(this.Square28);
            this._squares.Add(this.Square29);
            this._squares.Add(this.Square30);
            this._squares.Add(this.Square31);
            this._squares.Add(this.Square32);
            this._squares.Add(this.Square33);
            this._squares.Add(this.Square34);
            this._squares.Add(this.Square35);
            this._squares.Add(this.Square36);
            this._squares.Add(this.Square37);
            this._squares.Add(this.Square38);
            this._squares.Add(this.Square39);
            this._squares.Add(this.Square40);
            this._squares.Add(this.Square41);
            this._squares.Add(this.Square42);
            this._squares.Add(this.Square43);
            this._squares.Add(this.Square44);
            this._squares.Add(this.Square45);
            this._squares.Add(this.Square46);
            this._squares.Add(this.Square47);
            this._squares.Add(this.Square48);
            this._squares.Add(this.Square49);
            this._squares.Add(this.Square50);
            this._squares.Add(this.Square51);
            this._squares.Add(this.Square52);
            this._squares.Add(this.Square53);
            this._squares.Add(this.Square54);
            this._squares.Add(this.Square55);
            this._squares.Add(this.Square56);
            this._squares.Add(null); // this is a path
            this._squares.Add(this.Square58);
            this._squares.Add(this.Square59);
            this._squares.Add(this.Square60);
            this._squares.Add(this.Square61);
            this._squares.Add(this.Square62);
            this._squares.Add(null); // this is a path
            this._squares.Add(this.Square64);
            this._squares.Add(this.Square65);
            this._squares.Add(this.Square66);
            this._squares.Add(this.Square67);
            this._squares.Add(this.Square68);
            this._squares.Add(null); // this is a path
            this._squares.Add(this.Square70);
            this._squares.Add(this.Square71);
            this._squares.Add(this.Square72);
            this._squares.Add(this.Square73);
            this._squares.Add(this.Square74);
            this._squares.Add(null); // this is a path
            this._squares.Add(this.Square76);
            this._squares.Add(this.Square77);
            this._squares.Add(this.Square78);
            this._squares.Add(this.Square79);
            this._squares.Add(this.Square80);
            this._squares.Add(this.Square81);
            this._squares.Add(this.Square82);
            this._squares.Add(this.Square83);
            this._squares.Add(this.Square84);
            this._squares.Add(this.Square85);
            this._squares.Add(this.Square86);
            this._squares.Add(this.Square87);
            this._squares.Add(this.Square88);
            this._squares.Add(this.Square89);
            this._squares.Add(this.Square90);
            this._squares.Add(this.Square91);
        }

        void ResizeBoard(Size boardSize)
        {
            double squareWidth = boardSize.Width / 15.0d;
            double squareHeight = boardSize.Height / 15.0d;
            Canvas.SetLeft(this._squares[0], squareWidth * 6.0d);
            double whiteHouseBorderWidth = squareWidth * 2.0d / 3.0d;
            double whiteHouseBorderHeight = squareHeight * 2.0d / 3.0d;            

            for (int index = 0; index < this._squares.Count; index++)
            {
                Rectangle currentSquare = this._squares[index];
                Rectangle previousSquare = null;
                if (index > 0) previousSquare = this._squares[index - 1];
                if (currentSquare == null) continue; // path shapes drawing goal triangles

                currentSquare.Width = squareWidth;
                currentSquare.Height = squareHeight;

                switch (index)
                {
                    case 1:
                    case 2:
                        // The white squares at the top of the board
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[0]) + index * squareWidth);
                        break;
                    case 3:
                    case 4:
                    case 5:
                    case 6:
                    case 7:
                        // South by yellow house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare) + squareHeight);
                        break;
                    case 8:
                        // First square south of yellow house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare) + squareWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare) + squareHeight);
                        break;
                    case 9:
                    case 10:
                    case 11:
                    case 12:
                    case 13:
                        // East by yellow house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare) + squareWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare));
                        break;
                    case 14:
                    case 15:
                        // East
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare) + squareHeight);
                        break;
                    case 16:
                    case 17:
                    case 18:
                    case 19:
                    case 20:
                        // West by green house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare) - squareWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare));
                        break;
                    case 21:
                        // First square west of green house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare) - squareWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare) + squareHeight);
                        break;
                    case 22:
                    case 23:
                    case 24:
                    case 25:
                    case 26:
                        // South by green house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare) + squareHeight);
                        break;
                    case 27:
                    case 28:
                        // South
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare) - squareWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare));
                        break;
                    case 29:
                    case 30:
                    case 31:
                    case 32:
                    case 33:
                        // North by blue house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare) - squareHeight);
                        break;
                    case 34:
                        // First square north of blue house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare) - squareWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare) - squareHeight);
                        break;
                    case 35:
                    case 36:
                    case 37:
                    case 38:
                    case 39:
                        // West by blue house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare) - squareWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare));
                        break;
                    case 40:
                    case 41:
                        // West
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare) - squareHeight);
                        break;
                    case 42:
                    case 43:
                    case 44:
                    case 45:
                    case 46:
                        // East by red house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare) + squareWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare));
                        break;
                    case 47:
                        // First square east of red house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare) + squareWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare) - squareHeight);                        
                        break;
                    case 48:
                    case 49:
                    case 50:
                    case 51:
                        // North by red house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(previousSquare));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(previousSquare) - squareHeight);
                        break;
                    case 52:
                    case 53:
                    case 54:
                    case 55:
                    case 56:
                        // Path to yellow goal
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[index - 49]) - squareWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[index - 49]));                        
                        break;
                    case 58:
                    case 59:
                    case 60:
                    case 61:
                    case 62:
                        // Path to the green goal
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[index - 42]));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[index - 42]) - squareHeight);                        
                        break;
                    case 64:
                    case 65:
                    case 66:
                    case 67:
                    case 68:
                        // Path to the blue goal
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[index - 35]) + squareWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[index - 35]));                        
                        break;
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                        // Path to the red goal
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[index - 28]));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[index - 28]) + squareHeight);                        
                        break;
                    case 88:
                        // In the red house
                        Canvas.SetLeft(currentSquare, squareWidth + whiteHouseBorderWidth);
                        Canvas.SetTop(currentSquare, squareHeight * 2.0d + whiteHouseBorderHeight * 2.0d);                        
                        break;
                    case 89:
                        // In the red house
                        Canvas.SetLeft(currentSquare, squareWidth + whiteHouseBorderWidth);
                        Canvas.SetTop(currentSquare, squareHeight + whiteHouseBorderHeight);
                        break;
                    case 90:
                        // In the red house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[88]) + squareWidth + whiteHouseBorderWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[88]));                        
                        break;
                    case 91:
                        // In the red house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[90]));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[89]));                        
                        break;
                    case 76:
                        // In the yellow house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[2]) + squareWidth * 2.0d + whiteHouseBorderWidth);
                        Canvas.SetTop(currentSquare, squareHeight + whiteHouseBorderHeight);                        
                        break;
                    case 77:
                        // In the yellow house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[76]) + squareWidth + whiteHouseBorderWidth);
                        Canvas.SetTop(currentSquare, squareHeight + whiteHouseBorderHeight);                        
                        break;
                    case 78:
                        // In the yellow house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[76]));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[76]) + squareHeight + whiteHouseBorderHeight);                        
                        break;
                    case 79:
                        // In the yellow house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[77]));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[78]));
                        break;
                    case 80:
                        // In the green house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[77]));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[15]) + squareHeight * 2.0d + whiteHouseBorderHeight);
                        break;
                    case 81:
                        // In the green house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[80]));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[80]) + squareHeight + whiteHouseBorderHeight);
                        break;
                    case 82:
                        // In the green house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[76]));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[80]));
                        break;
                    case 83:
                        // In the green house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[82]));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[81]));
                        break;
                    case 84:
                        // In the blue house
                        Canvas.SetLeft(currentSquare, squareWidth * 2.0d + whiteHouseBorderWidth * 2.0d);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[83]));                        
                        break;
                    case 85:
                        // In the blue house
                        Canvas.SetLeft(currentSquare, squareWidth + whiteHouseBorderWidth);
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[84]));                        
                        break;
                    case 86:
                        // In the blue house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[84]));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[82]));                        
                        break;
                    case 87:
                        // In the blue house
                        Canvas.SetLeft(currentSquare, Canvas.GetLeft(this._squares[85]));
                        Canvas.SetTop(currentSquare, Canvas.GetTop(this._squares[86]));                        
                        break;
                }

                // Red house
                RedHouse.Width = squareWidth * 6;
                RedHouse.Height = squareHeight * 6;
                InnerRedHouse.Width = squareWidth * 4;
                InnerRedHouse.Height = squareHeight * 4;
                Canvas.SetLeft(InnerRedHouse, squareWidth);
                Canvas.SetTop(InnerRedHouse, squareHeight);

                // Yellow house
                YellowHouse.Width = RedHouse.Width;
                YellowHouse.Height = RedHouse.Height;
                Canvas.SetLeft(YellowHouse, squareWidth * 9);
                InnerYellowHouse.Width = InnerRedHouse.Width;
                InnerYellowHouse.Height = InnerRedHouse.Height;
                Canvas.SetLeft(InnerYellowHouse, squareWidth * 10);
                Canvas.SetTop(InnerYellowHouse, squareHeight);

                // Green house
                GreenHouse.Width = RedHouse.Width;
                GreenHouse.Height= RedHouse.Height;
                Canvas.SetLeft(GreenHouse, Canvas.GetLeft(YellowHouse));
                Canvas.SetTop(GreenHouse, squareHeight * 9);
                InnerGreenHouse.Width = InnerRedHouse.Width;
                InnerGreenHouse.Height = InnerRedHouse.Height;
                Canvas.SetLeft(InnerGreenHouse, Canvas.GetLeft(InnerYellowHouse));
                Canvas.SetTop(InnerGreenHouse, squareHeight * 10);

                // Blue house
                BlueHouse.Width = RedHouse.Width;
                BlueHouse.Height = RedHouse.Height;
                Canvas.SetTop(BlueHouse, Canvas.GetTop(GreenHouse));
                InnerBlueHouse.Width = InnerRedHouse.Width;
                InnerBlueHouse.Height = InnerRedHouse.Height;
                Canvas.SetLeft(InnerBlueHouse, Canvas.GetLeft(InnerRedHouse));
                Canvas.SetTop(InnerBlueHouse, Canvas.GetTop(InnerGreenHouse));

                // Red goal                
                Canvas.SetLeft(Square75, Canvas.GetLeft(Square47));
                Canvas.SetTop(Square75, Canvas.GetTop(Square46));
                Square75.Width = squareWidth * 1.5d;
                Square75.Height = squareHeight * 3.0d;

                // Yellow goal
                Canvas.SetLeft(Square57, Canvas.GetLeft(Square75));
                Canvas.SetTop(Square57, Canvas.GetTop(Square75));
                Square57.Width = squareWidth * 3.0d;
                Square57.Height = squareHeight * 1.5d;

                // Green goal
                Canvas.SetLeft(Square63, Canvas.GetLeft(Square75) + squareWidth * 1.5d);
                Canvas.SetTop(Square63, Canvas.GetTop(Square8));
                Square63.Width = Square75.Width;
                Square63.Height = Square75.Height;

                // Blue goal
                Canvas.SetLeft(Square69, Canvas.GetLeft(Square75));
                Canvas.SetTop(Square69, Canvas.GetTop(Square75) + squareHeight * 1.5d);
                Square69.Width = Square57.Width;
                Square69.Height = Square57.Height;
            }
        }
    }
}
