using System;
using System.Collections.Generic;
using System.Text;

namespace Lokeiv.Games.Dice
{
    public abstract class Die
    {
        protected DieValue _value = null;
        protected Random _randomizer = null;

        # region Public properties

        public DieValue Value
        {
            get { return this._value; }
            set { this._value = value; }
        }

        #endregion

        #region Public events

        public delegate void DieRolledEventHandler(object die, DieRolledEventArgs e);

        public event DieRolledEventHandler DieRolled;

        protected void OnDieRolled(object die, DieRolledEventArgs e)
        {
            if (this.DieRolled != null)
            {
                this.DieRolled(this, e);
            }
        }

        #endregion

        #region Constructors

        public Die()
        {            
            this._randomizer = new Random();
        }

        #endregion

        protected abstract DieValue GetNewRandomValue();

        public DieValue Roll()
        {
            this._value = this.GetNewRandomValue();
            this.OnDieRolled(this, new DieRolledEventArgs(this._value));
            return this._value;
        }

    }
}
